<?php

function autoupdate_deltree($path)
{
  if (is_dir($path))
  {
    $fh = opendir($path);
    while ($file = readdir($fh))
    {
      if ($file != '.' and $file != '..')
      {
        $pathfile = $path . '/' . $file;
        if (is_dir($pathfile))
        {
          autoupdate_deltree($pathfile);
        }
        else
        {
          @unlink($pathfile);
        }
      }
    }
    closedir($fh);
    return @rmdir($path);
  }
}

function check_version_for_autoupdate($version=PHPWG_VERSION)
{
  global $conf, $header_notes;

  if (preg_match('/(\d+\.\d+)\.(\d+)/', $version, $matches) and @fetchRemote(PHPWG_URL.'/download/latest_version', $result))
  {
    $lines = @explode("\r\n", $result);
    $new_version = trim($lines[1]);
    $new_branch = preg_replace('/(\d+\.\d+)\.\d+/', '$1', $new_version);
    $actual_branch = $matches[1];
    $update_to =  $actual_branch . '.' . ($matches[2]+1);

    if (version_compare($version, $new_version) < 0
      and $actual_branch == $new_branch)
    {
      $path = $conf['local_data_dir'].'/autoupdate/';
      $code = $version.'_to_'.$update_to;
      $filename = $path.$version.'_to_'.$update_to.'.zip';
      mkgetdir($path);

      if (!file_exists($filename) or !filesize($filename))
      {
        $zip = @fopen($filename, 'w+');
        @fetchRemote(PHPWG_URL.'/download/dlcounter.php?code='.str_replace(array('.', '_'), '', $code), $zip);
        @fclose($zip);
      }

      if (file_exists($filename) and filesize($filename))
      {
        if (isset($_GET['autoupdate']) and preg_match('/\d+\.\d+\.\d+_to_'.preg_quote($version).'/', $_GET['autoupdate']))
        {
          redirect('admin.php?autoupdate='.$code);
        }
        else
        {
          array_push($header_notes,
            '<p>'.l10n('A new version of Piwigo is available.').'<br>',
            '<a href="admin.php?autoupdate='.$code.'" onClick="return confirm(\''.l10n('autoupdate_alert').'\');">'.l10n('Click here to upgrade automatically').'</a></p>'
          );
        }
      }
    }
  }
}

load_language('plugin.lang', dirname(__FILE__).'/');

if (isset($_GET['autoupdate']))
{
  if ($_GET['autoupdate'] == 'success')
  {
    array_push($page['infos'], sprintf(l10n('autoupdate_success'), PHPWG_VERSION));
  }
  elseif ($file = $conf['local_data_dir'].'/autoupdate/'.$_GET['autoupdate'].'.zip' and file_exists($file))
  {
    include_once(PHPWG_ROOT_PATH.'admin/include/pclzip.lib.php');
    $zip = new PclZip($file);
    if ($result = $zip->extract(PCLZIP_OPT_PATH, PHPWG_ROOT_PATH, PCLZIP_OPT_REMOVE_PATH, $_GET['autoupdate'], PCLZIP_OPT_REPLACE_NEWER))
    {
      if (file_exists(PHPWG_ROOT_PATH.'obsolete.list')
        and $old_files = file(PHPWG_ROOT_PATH.'obsolete.list', FILE_IGNORE_NEW_LINES)
        and !empty($old_files))
      {
        array_push($old_files, 'obsolete.list');
        foreach($old_files as $old_file)
        {
          $path = PHPWG_ROOT_PATH.$old_file;
          if (is_file($path))
          {
            @unlink($path);
          }
          elseif (is_dir($path))
          {
            autoupdate_deltree($path);
          }
        }
      }
      if (preg_match('/\d+\.\d+\.\d+_to_(\d+\.\d+\.\d+)/', $_GET['autoupdate'], $matches))
      {
        check_version_for_autoupdate($matches[1]);
      }
      autoupdate_deltree($conf['local_data_dir'].'/autoupdate');
      invalidate_user_cache(true);
      $template->delete_compiled_templates();
      redirect('admin.php?autoupdate=success');
    }
    else
    {
      autoupdate_deltree($conf['local_data_dir'].'/autoupdate');
      array_push($page['errors'], l10n('autoupdate_fail'));
    }
  }
  else
  {
    array_push($page['errors'], l10n('autoupdate_fail'));
  }
}
else
{
  check_version_for_autoupdate();
}

?>